diff --git a/web/pgadmin/static/js/components/Buttons.jsx b/web/pgadmin/static/js/components/Buttons.jsx
index c15e313d5..c446926c5 100644
--- a/web/pgadmin/static/js/components/Buttons.jsx
+++ b/web/pgadmin/static/js/components/Buttons.jsx
@@ -199,7 +199,7 @@ PgIconButton.propTypes = {
 export const PgButtonGroup = forwardRef(({children, ...props}, ref)=>{
   /* Tooltip does not work for disabled items */
   return (
-    <ButtonGroup disableElevation innerRef={ref} {...props}>
+    <ButtonGroup innerRef={ref} {...props}>
       {children}
     </ButtonGroup>
   );
diff --git a/web/pgadmin/static/js/components/FormComponents.jsx b/web/pgadmin/static/js/components/FormComponents.jsx
index cb78020b1..2dcd79d69 100644
--- a/web/pgadmin/static/js/components/FormComponents.jsx
+++ b/web/pgadmin/static/js/components/FormComponents.jsx
@@ -35,13 +35,13 @@ import * as DateFns from 'date-fns';
 
 import CodeMirror from './CodeMirror';
 import gettext from 'sources/gettext';
-import { showFileDialog } from '../helpers/legacyConnector';
 import _ from 'lodash';
 import { DefaultButton, PrimaryButton, PgIconButton } from './Buttons';
 import CustomPropTypes from '../custom_prop_types';
 import KeyboardShortcuts from './KeyboardShortcuts';
 import QueryThresholds from './QueryThresholds';
 import SelectThemes from './SelectThemes';
+import { showFileManager } from '../helpers/showFileManager';
 
 
 const useStyles = makeStyles((theme) => ({
@@ -326,11 +326,10 @@ FormInputDateTimePicker.propTypes = {
 
 /* Use forwardRef to pass ref prop to OutlinedInput */
 export const InputText = forwardRef(({
-  cid, helpid, readonly, disabled, value, onChange, controlProps, type, ...props }, ref) => {
+  cid, helpid, readonly, disabled, value, onChange, controlProps, type, size, ...props }, ref) => {
 
   const maxlength = typeof(controlProps?.maxLength) != 'undefined' ? controlProps.maxLength : 255;
 
-  const classes = useStyles();
   const patterns = {
     'numeric': '^-?[0-9]\\d*\\.?\\d*$',
     'int': '^-?[0-9]\\d*$',
@@ -356,12 +355,17 @@ export const InputText = forwardRef(({
     finalValue = controlProps.formatter.fromRaw(finalValue);
   }
 
+  const filteredProps = _.pickBy(props, (_v, key)=>(
+    /* When used in ButtonGroup, following props should be skipped */
+    !['color', 'disableElevation', 'disableFocusRipple', 'disableRipple'].includes(key)
+  ));
+
   return (
     <OutlinedInput
       ref={ref}
       color="primary"
       fullWidth
-      className={classes.formInput}
+      margin={size == 'small' ? 'dense' : 'none'}
       inputProps={{
         id: cid,
         maxLength: controlProps?.multiline ? null : maxlength,
@@ -378,7 +382,7 @@ export const InputText = forwardRef(({
         ...(controlProps?.onKeyDown && { onKeyDown: controlProps.onKeyDown })
       }
       {...controlProps}
-      {...props}
+      {...filteredProps}
       {...(['numeric', 'int'].indexOf(type) > -1 ? { type: 'tel' } : { type: type })}
     />
   );
@@ -394,6 +398,7 @@ InputText.propTypes = {
   onChange: PropTypes.func,
   controlProps: PropTypes.object,
   type: PropTypes.string,
+  size: PropTypes.string,
 };
 
 export function FormInputText({ hasError, required, label, className, helpMessage, testcid, ...props }) {
@@ -412,7 +417,6 @@ FormInputText.propTypes = {
   testcid: PropTypes.string,
 };
 
-/* Using the existing file dialog functions using showFileDialog */
 export function InputFileSelect({ controlProps, onChange, disabled, readonly, isvalidate = false, hideBrowseButton=false,validate, ...props }) {
   const inpRef = useRef();
   let textControlProps = {};
@@ -420,15 +424,24 @@ export function InputFileSelect({ controlProps, onChange, disabled, readonly, is
     const {placeholder} = controlProps;
     textControlProps = {placeholder};
   }
-  const onFileSelect = (value) => {
-    onChange && onChange(decodeURI(value));
-    inpRef.current.focus();
+  const showFileDialog = ()=>{
+    let params = {
+      supported_types: controlProps.supportedTypes || [],
+      dialog_type: controlProps.dialogType || 'select_file',
+      dialog_title: controlProps.dialogTitle || '',
+      btn_primary: controlProps.btnPrimary || '',
+    };
+    showFileManager(params, (fileName)=>{
+      onChange && onChange(decodeURI(fileName));
+      inpRef.current.focus();
+    });
   };
+
   return (
     <InputText ref={inpRef} disabled={disabled} readonly={readonly} onChange={onChange} controlProps={textControlProps} {...props} endAdornment={
       <>
         {!hideBrowseButton &&
-        <IconButton onClick={() => showFileDialog(controlProps, onFileSelect)}
+        <IconButton onClick={showFileDialog}
           disabled={disabled || readonly} aria-label={gettext('Select a file')}><FolderOpenRoundedIcon /></IconButton>
         }
         {isvalidate &&
@@ -1184,6 +1197,9 @@ const useStylesFormFooter = makeStyles((theme) => ({
   message: {
     marginLeft: theme.spacing(0.5),
   },
+  messageCenter: {
+    margin: 'auto',
+  },
   closeButton: {
     marginLeft: 'auto',
   },
@@ -1272,13 +1288,13 @@ FormInputSelectThemes.propTypes = {
 };
 
 
-export function NotifierMessage({ type = MESSAGE_TYPE.SUCCESS, message, closable = true, onClose = () => {/*This is intentional (SonarQube)*/ } }) {
+export function NotifierMessage({ type = MESSAGE_TYPE.SUCCESS, message, closable = true, showIcon=true, textCenter=false, onClose = () => {/*This is intentional (SonarQube)*/ } }) {
   const classes = useStylesFormFooter();
 
   return (
     <Box className={clsx(classes.container, classes[`container${type}`])}>
-      <FormIcon type={type} className={classes[`icon${type}`]} />
-      <Box className={classes.message}>{HTMLReactParse(message || '')}</Box>
+      {showIcon && <FormIcon type={type} className={classes[`icon${type}`]} />}
+      <Box className={textCenter ? classes.messageCenter : classes.message}>{HTMLReactParse(message || '')}</Box>
       {closable && <IconButton className={clsx(classes.closeButton, classes[`icon${type}`])} onClick={onClose}>
         <FormIcon close={true} />
       </IconButton>}
@@ -1290,6 +1306,8 @@ NotifierMessage.propTypes = {
   type: PropTypes.oneOf(Object.values(MESSAGE_TYPE)).isRequired,
   message: PropTypes.string,
   closable: PropTypes.bool,
+  showIcon: PropTypes.bool,
+  textCenter: PropTypes.bool,
   onClose: PropTypes.func,
 };
 
diff --git a/web/pgadmin/static/js/components/PgReactDataGrid.jsx b/web/pgadmin/static/js/components/PgReactDataGrid.jsx
new file mode 100644
index 000000000..210d8c980
--- /dev/null
+++ b/web/pgadmin/static/js/components/PgReactDataGrid.jsx
@@ -0,0 +1,88 @@
+import React from 'react';
+import ReactDataGrid from 'react-data-grid';
+import { makeStyles } from '@material-ui/core';
+import clsx from 'clsx';
+import PropTypes from 'prop-types';
+import CustomPropTypes from '../custom_prop_types';
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    height: '100%',
+    color: theme.palette.text.primary,
+    backgroundColor: theme.otherVars.qtDatagridBg,
+    fontSize: '12px',
+    border: 'none',
+    '--rdg-selection-color': theme.palette.primary.main,
+    '& .rdg-cell': {
+      ...theme.mixins.panelBorder.right,
+      ...theme.mixins.panelBorder.bottom,
+      fontWeight: 'abc',
+      '&[aria-colindex="1"]': {
+        padding: 0,
+      },
+      '&[aria-selected=true]:not([role="columnheader"])': {
+        outlineWidth: '0px',
+        outlineOffset: '0px',
+      }
+    },
+    '& .rdg-header-row .rdg-cell': {
+      padding: 0,
+    },
+    '& .rdg-header-row': {
+      backgroundColor: theme.palette.background.default,
+      fontWeight: 'normal',
+    },
+    '& .rdg-row': {
+      backgroundColor: theme.palette.background.default,
+      '&[aria-selected=true]': {
+        backgroundColor: theme.palette.primary.light,
+        color: theme.otherVars.qtDatagridSelectFg,
+      },
+    }
+  },
+  cellSelection: {
+    '& .rdg-cell': {
+      '&[aria-selected=true]:not([role="columnheader"])': {
+        outlineWidth: '1px',
+        outlineOffset: '-1px',
+        backgroundColor: theme.palette.primary.light,
+        color: theme.otherVars.qtDatagridSelectFg,
+      }
+    },
+  },
+  hasSelectColumn: {
+    '& .rdg-cell': {
+      '&[aria-selected=true][aria-colindex="1"]': {
+        outlineWidth: '2px',
+        outlineOffset: '-2px',
+        backgroundColor: theme.otherVars.qtDatagridBg,
+        color: theme.palette.text.primary,
+      }
+    },
+    '& .rdg-row[aria-selected=true] .rdg-cell:nth-child(1)': {
+      backgroundColor: theme.palette.primary.main,
+      color: theme.palette.primary.contrastText,
+    }
+  }
+}));
+
+
+export default function PgReactDataGrid({gridRef, className, hasSelectColumn=true, ...props}) {
+  const classes = useStyles();
+  let finalClassName = [classes.root];
+  hasSelectColumn && finalClassName.push(classes.hasSelectColumn);
+  props.enableCellSelect && finalClassName.push(classes.cellSelection);
+  finalClassName.push(className);
+  return <ReactDataGrid
+    ref={gridRef}
+    className={clsx(finalClassName)}
+    {...props}
+  />;
+}
+
+PgReactDataGrid.propTypes = {
+  gridRef: CustomPropTypes.ref,
+  className: CustomPropTypes.className,
+  hasSelectColumn: PropTypes.bool,
+  enableCellSelect: PropTypes.bool,
+};
diff --git a/web/pgadmin/static/js/helpers/ModalProvider.jsx b/web/pgadmin/static/js/helpers/ModalProvider.jsx
index 80523fe04..510cb96dc 100644
--- a/web/pgadmin/static/js/helpers/ModalProvider.jsx
+++ b/web/pgadmin/static/js/helpers/ModalProvider.jsx
@@ -22,7 +22,7 @@ import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
 import { Rnd } from 'react-rnd';
 import { ExpandDialogIcon, MinimizeDialogIcon } from '../components/ExternalIcon';
 
-const ModalContext = React.createContext({});
+export const ModalContext = React.createContext({});
 const MIN_HEIGHT = 190;
 const MIN_WIDTH = 500;
 
diff --git a/web/pgadmin/static/js/helpers/showFileManager.js b/web/pgadmin/static/js/helpers/showFileManager.js
new file mode 100644
index 000000000..fc658920c
--- /dev/null
+++ b/web/pgadmin/static/js/helpers/showFileManager.js
@@ -0,0 +1,6 @@
+import pgAdmin from 'sources/pgadmin';
+import 'pgadmin.tools.file_manager';
+
+export function showFileManager(...args) {
+  pgAdmin.Tools.FileManager.show(...args);
+}
diff --git a/web/pgadmin/static/js/tree/tree.js b/web/pgadmin/static/js/tree/tree.js
index 839016adf..467822b9f 100644
--- a/web/pgadmin/static/js/tree/tree.js
+++ b/web/pgadmin/static/js/tree/tree.js
@@ -14,8 +14,6 @@ import pgAdmin from 'sources/pgadmin';
 import { FileType } from 'react-aspen';
 import { TreeNode } from './tree_nodes';
 
-import { isValidData } from 'sources/utils';
-
 function manageTreeEvents(event, eventName, item) {
   let d = item ? item._metadata.data : [];
   let node_metadata = item ? item._metadata : {};
@@ -594,6 +592,6 @@ export function findInTree(rootNode, path) {
   })(rootNode);
 }
 
-let isValidTreeNodeData = isValidData;
+let isValidTreeNodeData = (data) => (!_.isEmpty(data));
 
 export { isValidTreeNodeData };
diff --git a/web/pgadmin/static/js/utils.js b/web/pgadmin/static/js/utils.js
index 0602921d4..5f5134834 100644
--- a/web/pgadmin/static/js/utils.js
+++ b/web/pgadmin/static/js/utils.js
@@ -7,7 +7,7 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
-import _ from 'underscore';
+import _ from 'lodash';
 import $ from 'jquery';
 import gettext from 'sources/gettext';
 import 'wcdocker';
@@ -115,14 +115,6 @@ export function findAndSetFocus(container) {
   }, 200);
 }
 
-let isValidData = (data) => (!_.isUndefined(data) && !_.isNull(data));
-let isFunction = (fn) => (_.isFunction(fn));
-let isString = (str) => (_.isString(str));
-
-export {
-  isValidData, isFunction, isString,
-};
-
 export function getEpoch(inp_date) {
   let date_obj = inp_date ? inp_date : new Date();
   return parseInt(date_obj.getTime()/1000);
@@ -456,6 +448,10 @@ export function getBrowser() {
     tem=/\brv[ :]+(\d+)/g.exec(ua) || [];
     return {name:'IE', version:(tem[1]||'')};
   }
+  if(ua.startsWith('Nwjs')) {
+    let nwjs = ua.split('-')[0]?.split(':');
+    return {name:nwjs[0], version: nwjs[1]};
+  }
 
   if(M[1]==='Chrome') {
     tem=ua.match(/\bOPR|Edge\/(\d+)/);
@@ -480,3 +476,21 @@ export function checkTrojanSource(content, isPasteEvent) {
     Notify.alert(gettext('Trojan Source Warning'), msg);
   }
 }
+
+export function downloadBlob(blob, fileName) {
+  let urlCreator = window.URL || window.webkitURL,
+    downloadUrl = urlCreator.createObjectURL(blob),
+    link = document.createElement('a');
+
+  document.body.appendChild(link);
+
+  if (getBrowser() === 'IE' && window.navigator.msSaveBlob) {
+  // IE10+ : (has Blob, but not a[download] or URL)
+    window.navigator.msSaveBlob(blob, fileName);
+  } else {
+    link.setAttribute('href', downloadUrl);
+    link.setAttribute('download', fileName);
+    link.click();
+  }
+  document.body.removeChild(link);
+}
diff --git a/web/pgadmin/tools/__init__.py b/web/pgadmin/tools/__init__.py
index 711699a89..9ab20d574 100644
--- a/web/pgadmin/tools/__init__.py
+++ b/web/pgadmin/tools/__init__.py
@@ -64,9 +64,6 @@ class ToolsModule(PgAdminModule):
         from .sqleditor import blueprint as module
         app.register_blueprint(module)
 
-        from .storage_manager import blueprint as module
-        app.register_blueprint(module)
-
         from .user_management import blueprint as module
         app.register_blueprint(module)
 
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/index.js b/web/pgadmin/tools/erd/static/js/erd_tool/index.js
index 8563ac562..1c7a10d12 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/index.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/index.js
@@ -17,6 +17,9 @@ import Alertify from 'pgadmin.alertifyjs';
 import pgWindow from 'sources/window';
 import pgAdmin from 'sources/pgadmin';
 
+import ModalProvider from '../../../../../static/js/helpers/ModalProvider';
+import Theme from '../../../../../static/js/Theme';
+
 export default class ERDTool {
   constructor(container, params) {
     this.container = document.querySelector(container);
@@ -37,13 +40,17 @@ export default class ERDTool {
     });
 
     ReactDOM.render(
-      <BodyWidget
-        params={this.params}
-        getDialog={getDialog}
-        pgWindow={pgWindow}
-        pgAdmin={pgAdmin}
-        panel={panel}
-        alertify={Alertify} />,
+      <Theme>
+        <ModalProvider>
+          <BodyWidget
+            params={this.params}
+            getDialog={getDialog}
+            pgWindow={pgWindow}
+            pgAdmin={pgAdmin}
+            panel={panel}
+            alertify={Alertify} />
+        </ModalProvider>
+      </Theme>,
       this.container
     );
   }
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
index 4132ae1e9..6427292d3 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
@@ -27,6 +27,7 @@ import 'wcdocker';
 import Theme from '../../../../../../static/js/Theme';
 import TableSchema from '../../../../../../browser/server_groups/servers/databases/schemas/tables/static/js/table.ui';
 import Notify from '../../../../../../static/js/helpers/Notifier';
+import { ModalContext } from '../../../../../../static/js/helpers/ModalProvider';
 
 /* Custom react-diagram action for keyboard events */
 export class KeyboardShortcutAction extends Action {
@@ -61,6 +62,7 @@ export class KeyboardShortcutAction extends Action {
 
 /* The main body container for the ERD */
 export default class BodyWidget extends React.Component {
+  static contextType = ModalContext;
   constructor() {
     super();
     this.state = {
@@ -214,8 +216,6 @@ export default class BodyWidget extends React.Component {
       backgroundPosition: '0px 0px',
     });
 
-    this.props.pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:select_file', this.openFile, this);
-    this.props.pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:create_file', this.saveFile, this);
     this.props.pgAdmin.Browser.onPreferencesChange('erd', () => {
       this.setState({
         preferences: this.props.pgWindow.pgAdmin.Browser.get_preferences_for_module('erd'),
@@ -468,11 +468,10 @@ export default class BodyWidget extends React.Component {
 
   onLoadDiagram() {
     var params = {
-      'supported_types': ['pgerd'], // file types allowed
+      'supported_types': ['*','pgerd'], // file types allowed
       'dialog_type': 'select_file', // open select file dialog
     };
-    this.props.pgAdmin.FileManager.init();
-    this.props.pgAdmin.FileManager.show_dialog(params);
+    this.props.pgAdmin.Tools.FileManager.show(params, this.openFile.bind(this), null, this.context);
   }
 
   openFile(fileName) {
@@ -501,13 +500,12 @@ export default class BodyWidget extends React.Component {
       this.saveFile(this.state.current_file);
     } else {
       var params = {
-        'supported_types': ['pgerd'],
+        'supported_types': ['*','pgerd'],
         'dialog_type': 'create_file',
         'dialog_title': 'Save File',
         'btn_primary': 'Save',
       };
-      this.props.pgAdmin.FileManager.init();
-      this.props.pgAdmin.FileManager.show_dialog(params);
+      this.props.pgAdmin.Tools.FileManager.show(params, this.saveFile.bind(this), null, this.context);
     }
   }
 
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool_hook.js b/web/pgadmin/tools/erd/static/js/erd_tool_hook.js
index 9fa0a2e3a..dafc69afd 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool_hook.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool_hook.js
@@ -10,7 +10,7 @@
 define([
   'sources/pgadmin', 'pgadmin.tools.erd/erd_tool', 'pgadmin.browser',
   'pgadmin.browser.server.privilege', 'pgadmin.node.database', 'pgadmin.node.primary_key',
-  'pgadmin.node.foreign_key', 'pgadmin.browser.datamodel', 'pgadmin.file_manager',
+  'pgadmin.node.foreign_key', 'pgadmin.browser.datamodel', 'pgadmin.tools.file_manager',
 ], function(
   pgAdmin, ERDToolModule
 ) {
diff --git a/web/pgadmin/tools/import_export_servers/static/js/import_export_servers.js b/web/pgadmin/tools/import_export_servers/static/js/import_export_servers.js
index d2953a3d2..b436b79cf 100644
--- a/web/pgadmin/tools/import_export_servers/static/js/import_export_servers.js
+++ b/web/pgadmin/tools/import_export_servers/static/js/import_export_servers.js
@@ -9,7 +9,6 @@
 
 import React from 'react';
 import ReactDOM from 'react-dom';
-import 'pgadmin.file_manager';
 import gettext from 'sources/gettext';
 import Alertify from 'pgadmin.alertifyjs';
 import Theme from 'sources/Theme';
diff --git a/web/pgadmin/tools/sqleditor/static/js/SQLEditorModule.js b/web/pgadmin/tools/sqleditor/static/js/SQLEditorModule.js
index fcf606254..33587d7e5 100644
--- a/web/pgadmin/tools/sqleditor/static/js/SQLEditorModule.js
+++ b/web/pgadmin/tools/sqleditor/static/js/SQLEditorModule.js
@@ -20,8 +20,8 @@ var wcDocker = window.wcDocker;
 import pgWindow from 'sources/window';
 import pgAdmin from 'sources/pgadmin';
 import pgBrowser from 'pgadmin.browser';
-import 'pgadmin.file_manager';
 import 'pgadmin.tools.user_management';
+import 'pgadmin.tools.file_manager';
 import gettext from 'sources/gettext';
 import React from 'react';
 import ReactDOM from 'react-dom';
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolComponent.jsx b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolComponent.jsx
index 71b5bb16c..86966c73b 100644
--- a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolComponent.jsx
+++ b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolComponent.jsx
@@ -332,15 +332,6 @@ export default function QueryToolComponent({params, pgWindow, pgAdmin, selectedN
         }
       }
     });
-
-    pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:select_file', (fileName)=>{
-      eventBus.current.fireEvent(QUERY_TOOL_EVENTS.LOAD_FILE, fileName);
-    }, pgAdmin);
-
-    pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:create_file', (fileName)=>{
-      eventBus.current.fireEvent(QUERY_TOOL_EVENTS.SAVE_FILE, fileName);
-    }, pgAdmin);
-
     window.addEventListener('beforeunload', onBeforeUnload);
   }, []);
 
@@ -428,8 +419,9 @@ export default function QueryToolComponent({params, pgWindow, pgAdmin, selectedN
           'supported_types': ['*', 'sql'], // file types allowed
           'dialog_type': 'select_file', // open select file dialog
         };
-        pgAdmin.FileManager.init();
-        pgAdmin.FileManager.show_dialog(fileParams);
+        pgAdmin.Tools.FileManager.show(fileParams, (fileName)=>{
+          eventBus.current.fireEvent(QUERY_TOOL_EVENTS.LOAD_FILE, fileName);
+        }, null, modal);
       }],
       [QUERY_TOOL_EVENTS.TRIGGER_SAVE_FILE, (isSaveAs=false)=>{
         if(!isSaveAs && qtState.current_file) {
@@ -441,8 +433,9 @@ export default function QueryToolComponent({params, pgWindow, pgAdmin, selectedN
             'dialog_title': 'Save File',
             'btn_primary': 'Save',
           };
-          pgAdmin.FileManager.init();
-          pgAdmin.FileManager.show_dialog(fileParams);
+          pgAdmin.Tools.FileManager.show(fileParams, (fileName)=>{
+            eventBus.current.fireEvent(QUERY_TOOL_EVENTS.SAVE_FILE, fileName);
+          }, null, modal);
         }
       }],
       [QUERY_TOOL_EVENTS.LOAD_FILE_DONE, fileDone],
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx
index 5e51c6b4b..23c42a711 100644
--- a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx
+++ b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx
@@ -9,7 +9,7 @@
 import { Box, makeStyles } from '@material-ui/core';
 import _ from 'lodash';
 import React, {useState, useEffect, useContext, useRef, useLayoutEffect} from 'react';
-import ReactDataGrid, {Row, useRowSelection} from 'react-data-grid';
+import {Row, useRowSelection} from 'react-data-grid';
 import LockIcon from '@material-ui/icons/Lock';
 import EditIcon from '@material-ui/icons/Edit';
 import { QUERY_TOOL_EVENTS } from '../QueryToolConstants';
@@ -21,51 +21,12 @@ import MapIcon from '@material-ui/icons/Map';
 import { QueryToolEventsContext } from '../QueryToolComponent';
 import PropTypes from 'prop-types';
 import gettext from 'sources/gettext';
+import PgReactDataGrid from '../../../../../../static/js/components/PgReactDataGrid';
 
 export const ROWNUM_KEY = '$_pgadmin_rownum_key_$';
 export const GRID_ROW_SELECT_KEY = '$_pgadmin_gridrowselect_key_$';
 
 const useStyles = makeStyles((theme)=>({
-  root: {
-    height: '100%',
-    color: theme.palette.text.primary,
-    backgroundColor: theme.otherVars.qtDatagridBg,
-    fontSize: '12px',
-    border: 'none',
-    '--rdg-selection-color': theme.palette.primary.main,
-    '& .rdg-cell': {
-      ...theme.mixins.panelBorder.right,
-      ...theme.mixins.panelBorder.bottom,
-      fontWeight: 'abc',
-      '&[aria-colindex="1"]': {
-        padding: 0,
-      },
-      '&[aria-selected=true]:not([role="columnheader"]):not([aria-colindex="1"])': {
-        outlineWidth: '1px',
-        outlineOffset: '-1px',
-        backgroundColor: theme.palette.primary.light,
-        color: theme.otherVars.qtDatagridSelectFg,
-      }
-    },
-    '& .rdg-header-row .rdg-cell': {
-      padding: 0,
-    },
-    '& .rdg-header-row': {
-      backgroundColor: theme.palette.background.default,
-      fontWeight: 'normal',
-    },
-    '& .rdg-row': {
-      backgroundColor: theme.palette.background.default,
-      '&[aria-selected=true]': {
-        backgroundColor: theme.palette.primary.light,
-        color: theme.otherVars.qtDatagridSelectFg,
-        '& .rdg-cell:nth-child(1)': {
-          backgroundColor: theme.palette.primary.main,
-          color: theme.palette.primary.contrastText,
-        }
-      },
-    }
-  },
   columnHeader: {
     padding: '3px 6px',
     height: '100%',
@@ -408,11 +369,10 @@ export default function QueryToolDataGrid({columns, rows, totalRowCount, dataCha
 
   return (
     <DataGridExtrasContext.Provider value={{onSelectedCellChange, handleCopy}}>
-      <ReactDataGrid
+      <PgReactDataGrid
         id="datagrid"
         columns={readyColumns}
         rows={rows}
-        className={classes.root}
         headerRowHeight={40}
         rowHeight={25}
         mincolumnWidthBy={50}
diff --git a/web/regression/javascript/SchemaView/SchemaView.spec.js b/web/regression/javascript/SchemaView/SchemaView.spec.js
index 36757abba..aea2c1d40 100644
--- a/web/regression/javascript/SchemaView/SchemaView.spec.js
+++ b/web/regression/javascript/SchemaView/SchemaView.spec.js
@@ -15,7 +15,6 @@ import {TestSchema, TestSchemaAllTypes} from './TestSchema.ui';
 import pgAdmin from 'sources/pgadmin';
 import {messages} from '../fake_messages';
 import SchemaView from '../../../pgadmin/static/js/SchemaView';
-import * as legacyConnector from 'sources/helpers/legacyConnector';
 import Notify from '../../../pgadmin/static/js/helpers/Notifier';
 import Theme from '../../../pgadmin/static/js/Theme';
 
@@ -191,18 +190,17 @@ describe('SchemaView', ()=>{
           simulateValidData();
 
           /* Press OK */
-          let confirmSpy = spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn)=>{
-            yesFn();
-          });
+          let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
           ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
-          expect(confirmSpy.calls.argsFor(0)[2]).toBe('Custom delete title');
-          expect(confirmSpy.calls.argsFor(0)[3]).toBe('Custom delete message');
+          confirmSpy.calls.argsFor(0)[2]();
 
+          expect(confirmSpy.calls.argsFor(0)[0]).toBe('Custom delete title');
+          expect(confirmSpy.calls.argsFor(0)[1]).toBe('Custom delete message');
           /* Press Cancel */
-          spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn, cancelFn)=>{
-            cancelFn();
-          });
+          confirmSpy.calls.reset();
           ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
+          confirmSpy.calls.argsFor(0)[3]();
+
           setTimeout(()=>{
             ctrlUpdate(done);
           }, 0);
@@ -297,7 +295,7 @@ describe('SchemaView', ()=>{
       }, 0);
     });
 
-    let onRestAction = (done, data)=> {
+    let onResetAction = (done, data)=> {
       ctrl.update();
       expect(ctrl.find('DefaultButton[data-test="Reset"]').prop('disabled')).toBeTrue();
       expect(ctrl.find('PrimaryButton[data-test="Save"]').prop('disabled')).toBeTrue();
@@ -316,7 +314,7 @@ describe('SchemaView', ()=>{
           /* Press OK */
           confirmSpy.calls.argsFor(0)[2]();
           setTimeout(()=>{
-            onRestAction(done, { id: undefined, field1: null, field2: null, fieldcoll: null });
+            onResetAction(done, { id: undefined, field1: null, field2: null, fieldcoll: null });
           }, 0);
         }, 0);
       });
@@ -390,7 +388,9 @@ describe('SchemaView', ()=>{
         ctrl.find('MappedCellControl[id="field5"]').at(2).find('input').simulate('change', {target: {value: 'rval53'}});
 
         /* Remove the 1st row */
+        let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
         ctrl.find('DataTableRow').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
+        confirmSpy.calls.argsFor(0)[2]();
 
         /* Edit the 2nd row which is first now*/
         ctrl.find('MappedCellControl[id="field5"]').at(0).find('input').simulate('change', {target: {value: 'rvalnew'}});
@@ -403,11 +403,6 @@ describe('SchemaView', ()=>{
             mode: 'edit',
           }
         });
-
-        /* Press OK */
-        spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn)=>{
-          yesFn();
-        });
       });
       it('init', (done)=>{
         setTimeout(()=>{
@@ -463,9 +458,9 @@ describe('SchemaView', ()=>{
           let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
           ctrl.find('DefaultButton[data-test="Reset"]').simulate('click');
           /* Press OK */
-          confirmSpy.calls.argsFor(0)[2]();
+          confirmSpy.calls.mostRecent().args[2]();
           setTimeout(()=>{
-            onRestAction(done, {});
+            onResetAction(done, {});
           }, 0);
         }, 0);
       });
diff --git a/web/regression/javascript/components/FormComponents.spec.js b/web/regression/javascript/components/FormComponents.spec.js
index be70cb272..635e09756 100644
--- a/web/regression/javascript/components/FormComponents.spec.js
+++ b/web/regression/javascript/components/FormComponents.spec.js
@@ -28,10 +28,10 @@ import {FormInputText, FormInputFileSelect, FormInputSQL,
   FormInputColor,
   FormFooterMessage,
   MESSAGE_TYPE} from '../../../pgadmin/static/js/components/FormComponents';
-import * as legacyConnector from '../../../pgadmin/static/js/helpers/legacyConnector';
 import CodeMirror from '../../../pgadmin/static/js/components/CodeMirror';
 import { ToggleButton } from '@material-ui/lab';
 import { DefaultButton, PrimaryButton } from '../../../pgadmin/static/js/components/Buttons';
+import * as showFileManager from '../../../pgadmin/static/js/helpers/showFileManager';
 
 /* MUI Components need to be wrapped in Theme for theme vars */
 describe('FormComponents', ()=>{
@@ -118,7 +118,7 @@ describe('FormComponents', ()=>{
     let ThemedFormInputFileSelect = withTheme(FormInputFileSelect), ctrl;
 
     beforeEach(()=>{
-      spyOn(legacyConnector, 'showFileDialog').and.callFake((controlProps, onFileSelect)=>{
+      spyOn(showFileManager, 'showFileManager').and.callFake((controlProps, onFileSelect)=>{
         onFileSelect('selected/file');
       });
       ctrl = mount(
diff --git a/web/regression/javascript/erd/ui_components/body_widget_spec.js b/web/regression/javascript/erd/ui_components/body_widget_spec.js
index 74afced32..04f9fa13c 100644
--- a/web/regression/javascript/erd/ui_components/body_widget_spec.js
+++ b/web/regression/javascript/erd/ui_components/body_widget_spec.js
@@ -38,12 +38,11 @@ let pgAdmin = {
       app_version_int: 1234,
     },
   },
-  FileManager: {
-    init: jasmine.createSpy(),
-    show_dialog: jasmine.createSpy(),
-  },
   Tools: {
     SQLEditor: {},
+    FileManager: {
+      show: jasmine.createSpy(),
+    },
   }
 };
 
@@ -360,7 +359,7 @@ describe('ERD BodyWidget', ()=>{
 
   it('onLoadDiagram', ()=>{
     bodyInstance.onLoadDiagram();
-    expect(pgAdmin.FileManager.show_dialog).toHaveBeenCalled();
+    expect(pgAdmin.Tools.FileManager.show).toHaveBeenCalled();
   });
 
   it('openFile', (done)=>{
@@ -389,9 +388,10 @@ describe('ERD BodyWidget', ()=>{
       done();
     });
 
+    pgAdmin.Tools.FileManager.show.calls.reset();
     bodyInstance.onSaveDiagram(true);
-    expect(pgAdmin.FileManager.show_dialog).toHaveBeenCalledWith({
-      'supported_types': ['pgerd'],
+    expect(pgAdmin.Tools.FileManager.show.calls.argsFor(0)[0]).toEqual({
+      'supported_types': ['*','pgerd'],
       'dialog_type': 'create_file',
       'dialog_title': 'Save File',
       'btn_primary': 'Save',
